#!/usr/bin/python
"""
pytto.py
Licence: GPL
"""
import random, sys
if sys.version[0] == '2':
    import pygtk
    pygtk.require('2.0')

from gtk import *
import gtk.glade
from client import *

def sleeper():
    timeout_add(400, sleeper)
    time.sleep(0.001)

class Pytto:
    # System
    def __init__(self):
        self.core = None
        self.selectedNum = 0
        self.window = None

    # Internal
    def initGui(self):
        xml = self.xml = gtk.glade.XML('client.glade')
        widget = self.widget = xml.get_widget('window')
        xml.signal_autoconnect({
            'on_btn_clear_clicked': self.on_btn_clear_clicked,
            'on_btn_buy_clicked': self.on_btn_buy_clicked,
            'on_btn_random_clicked': self.on_btn_random_clicked,
            'on_btn_rnb_clicked': self.on_btn_rnb_clicked,
            'on_btn_textview_clear_clicked': self.on_btn_textview_clear_clicked,
            'on_window_destroy': self.die,
            'on_quit_activate': self.die
        })
        game = self.game = xml.get_widget('frame')
        game.add(self.game_make())
        widget.show_all()

    def get_usr_selected(self):
        l = []
        wl = self.game.get_children()[0].get_children()
        for w in wl:
            if w.get_active():
                l.append(int(w.get_label()))
        return l
    
    def die(self, arg):
        if self.core is not None:
            self.core.close()

        mainquit()

    def game_make(self):
        table = Table(9, 5, TRUE)
        for x in range(5):
            for y in range(9):
                b = CheckButton()
                b.set_label(str((x*9)+y+1))
                b.connect("clicked", self.on_b_clicked)
                table.attach_defaults(b, x, x+1, y, y+1)
        return table

    def clear(self):
        wl = self.game.get_children()[0].get_children()
        for w in wl:
            if w.get_active():
                w.set_active(0)
        self.selectedNum = 0
    
    def loop(self):
        if sys.platform == 'win32' :
            timeout_add(400, sleeper)
        else:
            try:
                threads_init()
            except:
                timeout_add(400, sleeper)

        mainloop()

    # Get/Set
    def getCore(self): return self.core
    def setCore(self, core): self.core = core

    # Event Handler
    def on_btn_textview_clear_clicked(self, arg):
        textview = self.xml.get_widget('textview')
        buf = textview.get_buffer()
        sob, eob = buf.get_bounds()
        buf.delete(sob, eob)

    def on_btn_clear_clicked(self, arg):
        self.clear()

    def on_btn_random_clicked(self, arg):
        self.clear()
        numbers = []
        while len(numbers) < 6:
            anynumber = random.randint(1, 45)
            if anynumber not in numbers:
                numbers.append(anynumber)

        numbers.sort()
        btns = self.game.get_children()[0].get_children()

        for i in numbers:
            btns[45 - i].clicked()

    def on_btn_rnb_clicked(self, arg):
        self.on_btn_random_clicked(arg)
        self.on_btn_buy_clicked(arg)

    def on_btn_buy_clicked(self, arg):
        usr_select = self.get_usr_selected()
        usr_select.sort()

        slip = listToString(usr_select)
        self.core.buy(slip)

    def on_b_clicked(self, arg):
        if self.selectedNum >= 6 and arg.get_active():
            arg.set_active(0)
            self.selectedNum += 1
            return
        if arg.get_active():
            self.selectedNum += 1
        else:
            self.selectedNum -= 1

    # External
    def notify(self, string):
        if self.widget is not None:
            textview = self.xml.get_widget('textview')
            buf = textview.get_buffer()

            #table = buf.get_tag_table()
            #warn_tag = gtk.TextTag("warning")
            #warn_tag.set_property("foreground", "blue")
            #table.add(warn_tag)

            sob, eob = buf.get_bounds()
            buf.insert(sob, string+'\n')
        else:
            print string

def __test__() :
    pytto = Pytto()
    core = ClientBase(ui=pytto)
    try:
        core.connect(('localhost', 19999))
        pytto.setCore(core)
        pytto.initGui()

        core_thr = threading.Thread(target=core)
        core_thr.start()

        name = getAnyName()
        core.login(name)

        pytto.loop()
    except:
        print 'connect failed!'

if __name__=='__main__':
    __test__()

